﻿Imports System
Imports System.Threading
Imports System.IO.Ports
Imports System.ComponentModel

Public Class Form1

    Dim scan As Boolean
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim Port As Array                                            '創建名為Port 的陣列 用來儲存系統可使用的ComPort
        Port = IO.Ports.SerialPort.GetPortNames()   '取得系統所有ComPort
        ComportComboBox.Items.AddRange(Port)  '將資料再ComportComboBox上顯示
        scan = True
        TxButton.Enabled = False
    End Sub

    'Private Sub ConnectButton_Click(sender As Object, e As EventArgs) Handles ConnectButton.Click
    '    SerialPort.PortName = ComportComboBox.Text  '將 ComportComboBox 資料給  SerialPort 的 PortName
    '    SerialPort.BaudRate = BaudComboBox.Text          '將 BaudComboBox 資料給 SerialPort 的 BaudRate
    '    SerialPort.DataBits = 8                                             '資料位元長度 也可在圖型介面上新增輸入物件來讓使用者更改
    '    SerialPort.StopBits = IO.Ports.StopBits.One           '停止位元長度 也可在圖型介面上新增輸入物件來讓使用者更改
    '    SerialPort.Parity = IO.Ports.Parity.None                 '校驗位元長度 也可在圖型介面上新增輸入物件來讓使用者更改
    '    SerialPort.Open()                                                       '端口開啟
    'End Sub
    Private Sub ConnectButton_Click(sender As Object, e As EventArgs) Handles ConnectButton.Click
        scan = False
        Try
            SerialPort.PortName = ComportComboBox.Text
            SerialPort.BaudRate = BaudComboBox.Text
        Catch ex As Exception
            InfoLabel.ForeColor = Color.FromArgb(200, 16, 64)
            InfoLabel.Text = "ComPort or Baud Error"
        End Try
        SerialPort.DataBits = 8 '数据位
        SerialPort.StopBits = IO.Ports.StopBits.One '停止位
        SerialPort.Parity = IO.Ports.Parity.None '校验位
        SerialPort.WriteBufferSize = 2048
        SerialPort.WriteTimeout = 1000
        SerialPort.ReadBufferSize = 4096
        SerialPort.ReadTimeout = -1
        SerialPort.DtrEnable = True
        'SerialPort.DiscardInBuffer()
        Try
            SerialPort.Open()
            ConnectButton.BackColor = Color.FromArgb(32, 32, 32)
            CloseButton.BackColor = Color.FromArgb(0, 192, 0)
            InfoLabel.ForeColor = Color.FromArgb(0, 192, 0)
            InfoLabel.Text = "Connect Successful"
            ConnectButton.Enabled = False
            CloseButton.Enabled = True
            TxButton.Enabled = True
        Catch ex As Exception
            InfoLabel.ForeColor = Color.FromArgb(200, 16, 64)
            InfoLabel.Text = "Connect Fail"
        End Try

    End Sub
    'Private Sub TxButton_Click(sender As Object, e As EventArgs) Handles TxButton.Click
    '    SerialPort.Write(TxTextBox.Text) '將TextBox 資料傳出
    '    TxTextBox.Text = ""                       '清空 TextBox
    'End Sub
    Private Sub TxButton_Click(sender As Object, e As EventArgs) Handles TxButton.Click
        Try
            SerialPort.Write(TxTextBox.Text & vbCr)
            TxTextBox.Text = ""
            InfoLabel.ForeColor = Color.FromArgb(0, 192, 0)
            InfoLabel.Text = "Transfer Successful"
        Catch ex As Exception
            InfoLabel.ForeColor = Color.FromArgb(200, 16, 64)
            InfoLabel.Text = "Transfer Fail"
        End Try
    End Sub

    'Private Sub CloseButton_Click(sender As Object, e As EventArgs) Handles CloseButton.Click
    '    SerialPort.Close() '端口關閉
    'End Sub

    Private Sub CloseButton_Click(sender As Object, e As EventArgs) Handles CloseButton.Click
        scan = True
        Try
            SerialPort.Close()
            InfoLabel.ForeColor = Color.FromArgb(0, 192, 0)
            InfoLabel.Text = "Close Successful"
            ConnectButton.BackColor = Color.FromArgb(200, 16, 64)
            CloseButton.BackColor = Color.FromArgb(32, 32, 32)
            ConnectButton.Enabled = True
            CloseButton.Enabled = False
            TxButton.Enabled = False
        Catch ex As Exception
            InfoLabel.ForeColor = Color.FromArgb(200, 16, 64)
            InfoLabel.Text = "Close Fail"
        End Try
    End Sub

    Private Sub SerialPort_DataReceived(sender As Object, e As SerialDataReceivedEventArgs) Handles SerialPort.DataReceived
        ReceivedText(SerialPort.ReadExisting()) '當有資料進來觸發此事件來呼叫函式
    End Sub

    Delegate Sub SetTextCallback(ByVal [text] As String) '宣告一種具 "一個字串引數" 的 Sub(routine) 之類別.
    Private Sub ReceivedText(ByVal [text] As String) 'input from ReadExisting
        If Me.RxTextBox.InvokeRequired Then
            Dim x As New SetTextCallback(AddressOf ReceivedText) '新增一個x委派 類別為SetTextCallback (指定新建立的委派所要參考的程式)。
            Me.Invoke(x, New Object() {(text)}) '呼叫 x來執行 ReceivedText 並且回傳 [text]
        Else
            Me.RxTextBox.Text &= [text] 'append text
            Me.RxTextBox.SelectionStart = RxTextBox.Text.Length
            RxTextBox.ScrollToCaret()
            'textbox1.Refresh()
        End If
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If scan = True Then
            Dim Port As Array                                            '創建名為Port 的陣列 用來儲存系統可使用的ComPort
            Port = IO.Ports.SerialPort.GetPortNames()   '取得系統所有ComPort
            ComportComboBox.Items.Clear()
            ComportComboBox.Items.AddRange(Port)
        End If
    End Sub


End Class
